
#include "equation.h"
#include "ec_util.h"

void ec_flux (ConservedVars &ecF, const ConservedVars &lU, const ConservedVars &rU, const XtraVars &lXU, const XtraVars &rXU, int d)
{
  // caution: this is NOT the same (though looks similar in parts) as calc_point_flux(ecF, avg(lU, rU), d)
  ecF.h       = avg ( lU.h, rU.h ) * avg ( lXU.u[d], rXU.u[d] );
  ecF.hu[d]   = avg ( lU.h, rU.h ) * sqr ( avg ( lXU.u[d], rXU.u[d] ) ) + GRAVITY * avg ( sqr(lU.h), sqr(rU.h) ) / 2.0;
  ecF.hu[1-d] = avg ( lU.h, rU.h ) * avg ( lXU.u[d], rXU.u[d] ) * avg ( lXU.u[1-d], rXU.u[1-d] );
}

real avg  (const real &left, const real &right)
{
  return (right + left) / 2.0;
}

real jump (const real &left, const real &right)
{
  return right - left;
}
