
/* EQUATION SPECIFIC FVM routines
 * Wave (Wave equation)
 */

///::title:: Wave (Wave equation)

#include "equation.h"

void calc_point_flux(ConservedVars &F, const AllVariables &V, int d)
{
  F.v[d] = - V.U.w;
  F.w    = - V.U.k * V.U.v[d] / V.U.rho;
  F.k    = 0.0;
  F.rho  = 0.0;
}

void apply_constraints (ConservedVars &CV, XtraVars &XV)
{
  // Constraints for ConservedVars
  // Constraints for XtraVars
}

void calc_xtra(XtraVars &Xijk, const ConservedVars &Uijk, int i, int j, int k)
{
  Xijk.E = sqr( Uijk.v.norm() );
}

void calc_all_vars(AllVariables &V, const PrimitiveVars &P)
{
  P.toConservedVars(V.U);
  V.XU.E = sqr( P.v.norm() );
}

// TODO: not complete.
#if INDICATOR == 1
real indicator(int i, int j, int k, int d)
{
  ConservedVars &Uijk = U[i][j][k];
  return Uijk.w;
}
#endif
